﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Mail;
using System.Text;
using System.Threading.Tasks;

/*
 *         Progetto: Progetto "Posta GMail"
 * 
 *           Autore: Roberto Fuligni
 *  Ultima modifica: 09/05/2016
 *  
 *      Descrizione: Invia un messaggio di posta elettronica 
 *                   tramite SMTP e account GMail.
 *                   
 */

namespace Invia
{
    class Program
    {
        const string ServerSmtp = "smtp.gmail.com";
        const int PortaSmtp = 587;
        const bool AbilitaSSL = true;
        const string EmailFrom = "@gmail.com";
        const string EmailTo = "@gmail.com";
        
        static void Main(string[] args)
        {
            Console.WriteLine("Invio della posta elettronica al server {0}", ServerSmtp);
            Console.WriteLine();
            Console.Write("Password per l'account {0}: ", EmailFrom);
            string pw = LeggiPassword();

            MailMessage mail = new MailMessage();
            mail.From = new MailAddress(EmailFrom);
            mail.To.Add(EmailTo);
            mail.Subject = String.Format("Messaggio di test - {0}", DateTime.Now);
            mail.Body = String.Format("Messaggio di test inviato al server SMTP {0}", ServerSmtp);
            mail.IsBodyHtml = false;
            mail.Attachments.Add(new Attachment(@"..\..\computer.jpg"));

            SmtpClient smtp = new SmtpClient(ServerSmtp, PortaSmtp);
            try
            {
                Console.WriteLine("Invio in corso...");
                smtp.Credentials = new NetworkCredential(EmailFrom, pw);
                smtp.EnableSsl = AbilitaSSL;
                smtp.Send(mail);
                Console.WriteLine("Messaggio inviato con successo.");
            }
            catch (Exception ex) {
                Console.Error.WriteLine("Errore: {0}", ex.Message);
            }   

        }

        public static string LeggiPassword()
        {
            string password = "";
            ConsoleKeyInfo info = Console.ReadKey(true);
            while (info.Key != ConsoleKey.Enter)
            {
                if (info.Key != ConsoleKey.Backspace)
                {
                    Console.Write("*");
                    password += info.KeyChar;
                }
                else if (info.Key == ConsoleKey.Backspace)
                {
                    if (!string.IsNullOrEmpty(password))
                    {
                        password = password.Substring(0, password.Length - 1);
                        int pos = Console.CursorLeft;
                        Console.SetCursorPosition(pos - 1, Console.CursorTop);
                        Console.Write(" ");
                        Console.SetCursorPosition(pos - 1, Console.CursorTop);
                    }
                }
                info = Console.ReadKey(true);
            }
            Console.WriteLine();
            return password;
        }
    }
}
