﻿using OpenPop.Pop3;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ricevi
{
/*
 *         Progetto: Progetto "Posta GMail"
 * 
 *           Autore: Roberto Fuligni
 *  Ultima modifica: 09/05/2016
 *  
 *      Descrizione: Riceve un messaggio di posta elettronica 
 *                   tramite POP3 e account GMail.
 *                   
 *                   Richiede il componente aggiuntivo OpenPop.NET.
 *                   
 */

    class Program
    {
        const string ServerPop = "pop.gmail.com";
        const int PortaPop = 995;
        const bool AbilitaSSL = true;
        const string Account = "@gmail.com";
        static void Main(string[] args)
        {
            OpenPop.Mime.Message message = null;
            Console.WriteLine("Ricezione della posta elettronica dal server {0}", ServerPop);
            Console.WriteLine();
            Console.Write("Password per l'account {0}: ", Account);
            string pw = LeggiPassword();

            var client = new Pop3Client();
            try {
                client.Connect(ServerPop, PortaPop, AbilitaSSL);
                client.Authenticate(Account, pw);
                var count = client.GetMessageCount();
                Console.WriteLine("Numero di messaggi: {0}", count);
    
                for (int i = 1; i <= count; i++) {
                    message = client.GetMessage(i);
                    Console.WriteLine("{0}. {1}", i, message.Headers.Subject);
                }

                if (message != null)
                {
                    message = client.GetMessage(count);
                    Console.WriteLine();
                    Console.WriteLine("Dettagli del messaggio più recente");
                    Console.WriteLine("----------------------------------");
                    Console.WriteLine("Da: {0}", message.Headers.From);
                    Console.Write("A: ");
                    foreach (var i in message.Headers.To)
                        Console.Write("{0};", i);
                    Console.WriteLine();
                    Console.WriteLine("Oggetto: {0}", message.Headers.Subject);
                    Console.WriteLine("Corpo del messaggio: {0}", message.FindFirstPlainTextVersion().GetBodyAsText());
                    foreach(var att in message.FindAllAttachments()) {
                        string nomeFile = att.FileName;
                        File.WriteAllBytes(nomeFile, att.Body);
                        Console.WriteLine("Allegato: {0} (salvato su disco)", nomeFile);
                    }
                       
                    
                }


                client.Disconnect();
            }
            catch (Exception ex) {
                Console.Error.WriteLine("Errore: {0}", ex.Message);
            }
        }

        public static string LeggiPassword()
        {
            string password = "";
            ConsoleKeyInfo info = Console.ReadKey(true);
            while (info.Key != ConsoleKey.Enter)
            {
                if (info.Key != ConsoleKey.Backspace)
                {
                    Console.Write("*");
                    password += info.KeyChar;
                }
                else if (info.Key == ConsoleKey.Backspace)
                {
                    if (!string.IsNullOrEmpty(password))
                    {
                        password = password.Substring(0, password.Length - 1);
                        int pos = Console.CursorLeft;
                        Console.SetCursorPosition(pos - 1, Console.CursorTop);
                        Console.Write(" ");
                        Console.SetCursorPosition(pos - 1, Console.CursorTop);
                    }
                }
                info = Console.ReadKey(true);
            }
            Console.WriteLine();
            return password;
        }

    }
}
